//BilderSkalieren_302d.js
// 23.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Bilder skalieren und zentrieren.

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

// aktives Dokument notieren
var curDoc = app.documents[0];

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var pcVal   = prefVal[0]*1;
	var ck0     = false;
	var ctPic   = prefVal[1];
	if (ctPic  == "true") {
		ck0 = true;
	}
	var grpd    = prefVal[2];
	var ck1     = 1;
	var ck2     = 0;
	if (grpd == "1") {
		ck1 = 0;
		ck2 = 1;
	}
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	var pcVal = 100;
	var ck0   = false;
	var ck1   = 1;
	var ck2   = 0;
}

// den Skalierungswert usw. verlangen
var anArray = displayDialog(pcVal, ck0, ck1, ck2);
var pcVal   = anArray[0];
var ck0     = anArray[1];
var grpd    = anArray[2];

// eine eventuelle Auswahl speichern
var curSel  = app.selection;
var nSel    = curSel.length;
var nPicts  = 0;

// wenn nichts ausgewhlt ist ...
if (nSel == 0) {
	var allPicts = curDoc.links;
	var nPicts   = allPicts.length;
}
// ... sonst die Links der Auswahl auflisten
else {
	var allPicts = getLinks(nSel, curSel);
	var nPicts   = allPicts.length;
}

// eine Schleife durch die Links
for (var i=0; i<nPicts; i++) {
	var isLocked = false;
	try {
		var curPict  = allPicts[i].parent;
		var curFrame = curPict.parent;
		if (grpd == 0) {
			if (curFrame.locked == true) {
				isLocked = true;
				curFrame.locked = false;
			}
		}
		curPict.properties = {horizontalScale:pcVal, verticalScale:pcVal};
		if (ck0) {
			curPict.parent.fit(FitOptions.centerContent);
		}
		if (isLocked) {
			curFrame.locked = true;
		}
	}
	catch (e) {
	}
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(1000);
// das Fenster schliessen
dlog.close();


///////////// DIE FUNKTIONEN ///////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Skalieren302.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Skalieren302.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// den Dialog vorbereiten und anzeigen
function displayDialog(pcVal, ck0, ck1, ck2) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 110;
	var fieldWidth =  40;
	var aDialog = app.dialogs.add({name:"Bilder skalieren"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Skalierungswert", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var valField = realEditboxes.add({editValue:pcVal, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"%", minWidth:12});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"", minWidth:1});
			var centerCheckbox = checkboxControls.add({staticLabel:"Bilder zentrieren", checkedState:ck0});
			staticTexts.add({staticLabel:"", minWidth:4});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Gesperrte Bildrahmen"});
					staticTexts.add({staticLabel:" ", minWidth:10});
				}
				with(grButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"behandeln", checkedState:ck1});
					radiobuttonControls.add({staticLabel:"nicht behandeln", checkedState:ck2});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		var pcVal = valField.editValue;
		var ck0   = centerCheckbox.checkedState;
		var grDec = grButtons.selectedButton;
		aDialog.destroy();
		var prefsList = new Array (pcVal, ck0, grDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [pcVal, ck0, grDec];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Skalieren302.txt");
	}
	else {
		var f = File("~/Library/Preferences/Skalieren302.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// diese Funktion sammelt die Links der Auswahl
function getLinks(nSel, curSel) {
	var linkList = new Array ();
	// eine Schleife durch die Auswahl
	for (var p=0; p<nSel; p++) {
		if (curSel[p].hasOwnProperty("graphics") == true) {
			if ((curSel[p].contentType)*1 == 1735553140) { // = "GRAPHIC_TYPE"
				try {
					curLink = curSel[p].graphics[0].itemLink;
					linkList.push(curLink);
				}
				catch (e) {
				}
			}
		}
		else {
			var cName = curSel[p].constructor.name;
			if (cName == "Image" || cName == "PDF" || cName == "EPS") {
				try {
					curLink = curSel[p].itemLink;
					linkList.push(curLink);
				}
				catch (e) {
				}
			}
			if (cName == "Group") {
				var allObj = curSel[p].allPageItems;
				var nObj = allObj.length;
				for (m=0; m<nObj; m++) {
					try {
						curLink = allObj[m].graphics[0].itemLink;
						linkList.push(curLink);
					}
					catch (e) {
					}
				}
			}
		}
	}
	return linkList;
}